// This example app sends UDP packets first using the chrome_io wrapper
// and then using the chrome API directly. Only visible thing it does is
// that it prints several lines of output into the debug console.

import 'dart:html' as dom;
import 'dart:typed_data' as typed;

import 'package:chrome_gen/chrome_app.dart' as chrome;

//import 'dart:io';
//import 'package:io/io.dart';
import 'package:chrome_io/chrome_io.dart';

void main() {
  print('main');

  dartway();
  chromeway();
}

void dartway() {
  int port = 54652;

  RawDatagramSocket.bind('0.0.0.0', port).then((RawDatagramSocket s) {
    print("chrome_io.RawDatagramSocket $s; port: ${s.port}");
    print(s.readEventsEnabled);
    s.listen((RawSocketEvent e) {
      print("RawSocketEvent e: $e");
      switch(e) {
        case RawSocketEvent.READ:
          Datagram p = s.receive();
          print("Obtained datagram ${p}");

          print(p.data);
          var ed = p.data.map((int e) => e.toRadixString(16)).toList();
          print(ed);
          print(new String.fromCharCodes(p.data));
    }
  });
  s.send([10,20,30,65,66], new InternetAddress('127.0.0.1'), port);
  });
}

// https://code.google.com/p/chromium/codesearch#chromium/src/net/base/net_error_list.h
void chromeway() {
  if (!chrome.socket.available) {
    print("chrome.socket not available\n");
    return;
  }

  print("sending packet\n");

  var port = 54216;
  chrome.socket.create(chrome.SocketType.UDP).then((chrome.CreateInfo s) {
    chrome.socket.bind(s.socketId, '0.0.0.0', port).then((int ret) {
      print(ret);
      var handler;
      handler = (chrome.RecvFromInfo r) {
        print(r.resultCode);
        print(r.runtimeType);
        print(r.address);
        print(r.port);
        typed.Uint8List bufer = r.jsProxy['data'];
        //var data = bufer.getBytes();
        print(bufer.buffer);
        var ed = bufer.map((int e) => e.toRadixString(16)).toList();
        print(ed);
        print(new String.fromCharCodes(bufer));
        chrome.socket.recvFrom(s.socketId).then(handler);
      };
      chrome.socket.recvFrom(s.socketId).then(handler);
      dom.querySelector('#text_id').onClick.listen((event) {
        print('clicked!');
        var b = new chrome.ArrayBuffer.fromString("\xFE\xFD\x09\x58\xEF\xD0\xC8");
        for (var p in [8766, 2302, 2304, 27016])
        chrome.socket.sendTo(s.socketId, b, '0.0.0.0', p).then((chrome.SocketWriteInfo ret) {
          print(ret.bytesWritten);
        });
      });
    });
  });
}