// https://github.com/dart-lang/bleeding_edge/tree/master/dart/tests/standalone/io

part of chrome_io;

// FIXME: fill in the blanks
//http://stackoverflow.com/questions/18564676/extending-a-class-with-only-one-factory-constructor
class InternetAddress implements io.InternetAddress {

  String _addr;

  InternetAddress(this._addr);

  // TODO: implement address
  @override
  String get address => _addr;

  // TODO: implement host
  @override
  String get host => null;

  // TODO: implement isLinkLocal
  @override
  bool get isLinkLocal => null;

  // TODO: implement isLoopback
  @override
  bool get isLoopback => null;

  // TODO: implement isMulticast
  @override
  bool get isMulticast => null;

  @override
  Future<InternetAddress> reverse() {
    // TODO: implement reverse
  }

  // TODO: implement type
  @override
  InternetAddressType get type => null;

  @override
  void set type(InternetAddressType _type) {
    // TODO: implement type
  }
}

class RawDatagramSocket extends io.RawDatagramSocket implements Stream<RawSocketEvent> {
  bool readEventsEnabled = true;
  bool writeEventsEnabled = false;

  String _host;
  int _port;
  chrome.CreateInfo _s; // CreateInfo is something akin to an Unix file descriptor

  // work around having to send datagrams synchronously over asynchronous api
  int _bytesWritten = null;
  // the readFrom callback and calls to receive method need to be uncoupled
  Datagram _buffer;

  // http://stackoverflow.com/questions/11112506/what-are-the-semantics-of-internal
  RawDatagramSocket._internal(this._host, this._port, this._s);

  static Future<io.RawDatagramSocket> bind(
      host, int port, {bool reuseAddress: true}) {
    print ("RawDatagramSocket.bind: I am here!\n");
    return new Future.sync(() {
      return chrome.socket.create(chrome.SocketType.UDP).then((chrome.CreateInfo s) {
        return chrome.socket.bind(s.socketId, host, port).then((int ret) {
          print(ret);
          if (ret < 0) {
//FIXME
          }
          return new RawDatagramSocket._internal(host, port, s);
        });
      });
    });
  }

  int get port => _port;
  InternetAddress get address => new InternetAddress(_host);
  void close() {}

  // FIXME: find out what Radia Perlman prefers to say instead of "unreliable"
  /**
   * We need to go from asynchronous to synchronous here; until await is implemented
   * we need to fake the return value. UDP is unreliable, so we can pretend the
   * datagram was sent all right, as long as the errors get to the caller eventually.
   *
   * It sucks for development (hides errors) but should work fine in deployment.
   */
  @override
  int send(List<int> buffer, InternetAddress address, int port) {
    chrome.ArrayBuffer data = new chrome.ArrayBuffer.fromBytes(buffer);
    chrome.socket.sendTo(_s.socketId, data, address.address, port).then((chrome.SocketWriteInfo ret) {
      _bytesWritten = ret.bytesWritten;
      //FIXME: WRITE event should be probably signalled when we are ready to send a next packet
      if (writeEventsEnabled) {

      }
    });
    if (_bytesWritten == null || _bytesWritten >= 0) { // no information || previous call succeeded
      _bytesWritten = null;
      return buffer.length; //FIXME: what if buffer.length == 0?
    } else if (_bytesWritten < 0) { // error
      _bytesWritten = null;
      return 0; //FIXME: throwing exceptions?
    }
  }

  @override
  Datagram receive() {
    var ret = _buffer;
    _buffer = null;
    return ret;
  }

  @override
  void joinMulticast(InternetAddress group, {NetworkInterface interface}) {
    // TODO
  }

  @override
  void leaveMulticast(InternetAddress group, {NetworkInterface interface}) {
    // TODO
  }

  @override
  StreamSubscription<RawSocketEvent> listen(void onData(RawSocketEvent event), {Function onError, void onDone(), bool cancelOnError}) {
    if (readEventsEnabled) {
      // FIXME: this works for only one listener; I need to multiplex; I guess
      // there is a code for doing that already that I can reuse.
      var _read;
      _read = (chrome.RecvFromInfo r) {
        if (r.resultCode < 0) {
          //FIXME:
        }

        // FIXME: workaround
        Uint8List d = r.jsProxy['data'];
        // this might be hitting a bug in the Chrome API wrapper
        //var data = bufer.getBytes();

        if (readEventsEnabled) {
          chrome.socket.recvFrom(_s.socketId).then(_read);
        }
        _buffer = new Datagram(new List<int>.from(d), new InternetAddress(r.address), r.port);
        onData(RawSocketEvent.READ);
      };
      chrome.socket.recvFrom(_s.socketId).then(_read);
    }
    // WRITE is signalled from the send method
    // TODO: implement also the other event

    return null; //FIXME: what is the pattern to create StreamSubsciption objects?
  }
}